/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#ifndef __SOUND__
#define __SOUND__


#include "sizedefs.h"
#include "vesa20.h"


#define SND_MELODIC     0x01
#define SND_NOISE       0x02
#define SND_PERIODIC    0x04

#define SND_CHANNELS    7
#define SND_BUFSIZE     1024
#define SND_NBUFS       64


struct _snd_ {

        u_long          sound_enable;
        u_long          sb_port;
        u_long          sb_irq;
        u_long          sb_dma;
        u_char         *buffer;
        u_long          snd_rate;
        u_long          cur_buffer;
        u_long          buf_overlap;
        u_long          buf_empty[2];
        u_long          buf_addr;
        u_long          noise_gen;
        u_long          master_volume;
        u_long          master_switch;
        u_long          max_freq;
        u_long          chan_type[SND_CHANNELS];
        u_long          chan_volume[SND_CHANNELS];
        u_long          chan_freq[SND_CHANNELS];
        u_char          wave[(SND_BUFSIZE*SND_NBUFS)+4];
        long            count[SND_CHANNELS];
        u_long          cnt_wave;
        memdos          mem_dos;

};

extern volatile struct _snd_ snd;


u_long InitSB (u_long snd_rate);
void ShutDownSB (void);


#endif

