/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/

#include <dos.h>
#include <stdio.h>
#include "m68deb.h"



void main (int argc, char *argv[]) {

  FILE                 *file;
  long                  tmp;
  unsigned long         opcode;
  unsigned long         calls;


  printf ("\nMelody BugFixer 0.01\n");

  if (argc < 2) {
        //printf ("\nUsage: BugFix <eq-a> <eq-b> <cmp-a> <cmp-b> <cmp-c> <cmp-d>\n");
        printf ("\nUsage: TellCod <file>\n");
        exit (0);
  }

        if ((file = fopen (argv[1], "rb")) == NULL) {
                printf ("\nAborting due to error: failed to open %s\n",
                        argv[1]);
                exit (0);
        }

        while (!feof (file)) {
                fscanf (file, "op_%lx = %lu\n\r", &opcode, &calls);
                printf ("\nop_%lx = %lu, %s", opcode, calls, GiveOpCodeName ((u_short)opcode));
        }

/*  for (tmp = 0; tmp < 65536; tmp++) {
        if ((ops[0][tmp]) && (ops[1][tmp]) && (!ops[2][tmp]) && (!ops[3][tmp]) \
            && (!ops[4][tmp]) && (!ops[5][tmp])) {
                printf ("\nop_%lx -> f1=%lu f2=%lu", tmp, ops[0][tmp], ops[1][tmp]);
        }
  }*/

  printf ("\n\nDone.\n");

  /*for (tmp = 0; tmp < 6; tmp++) fclose (file[tmp]);*/
  fclose (file);
}


