;*************************************************************************
;
;                          st0rm SGE Source Code
;
;                          (c)1998 David Sanchez
;                           st0rm@melodysoft.com
;
;                        Released on 17th March 1999
;        
;
;       Este codigo fuente lo puedes utilizar para:
;
;       - Usarlo como fuente de informacin para tus proyectos.
;       - Continuar el proyecto st0rm.
;       - Empezar un emulador desde 0 teniendo este como base.
;
;       Lo nico que pido si te es util y lo usas, es que lo menciones en tu
;       proyecto.
;
;       Tendras que perdonarme la falta de comentarios y el desorden total,
;       aun asi puede ser util.
;
;
;       COMENTARIOS EN README.TXT
;
;*************************************************************************


.486P
.MODEL FLAT



_DATA SEGMENT DWORD PUBLIC 'DATA'

rd_buffer_pos           dd              ?
rd_ptr_scrl_a           dd              ?
rd_ptr_scrl_b           dd              ?
rd_v_cnt_a              dd              ?
rd_v_cnt_b              dd              ?
rd_desp_a               dd              ?
rd_desp_b               dd              ?

n_scrl                  dd              ?
th_cells                dd              ?
h_cell                  dd              ?
h_desp                  dd              ?
line                    dd              ?
flag_end                dd              ?


_DATA ENDS

_TEXT SEGMENT DWORD PUBLIC 'CODE'
	ASSUME	cs:_TEXT, ds:_DATA


include genesis.inc



EXTRN   memset:PROC

public  RenderLine

public  rd_buffer_pos
public  rd_ptr_scrl_a
public  rd_ptr_scrl_b
public  rd_v_cnt_a
public  rd_v_cnt_b
public  rd_desp_a
public  rd_desp_b



RenderLine      PROC

        pushad
        mov     edi, [rd_buffer_pos]
        cmp     [vdp+cell_mode], 0
        jne     short l40cell
        add     edi, 32
l40cell:
        mov     eax, [vdp+h_cells]
        mov     esi, [rd_ptr_scrl_b]
        add     eax, 2
        mov     [n_scrl], esi
        mov     [th_cells], eax
        mov     eax, [rd_desp_b]
        sub     esi, 2
        mov     ebx, eax
        and     eax, 7
        shr     ebx, 3
        mov     [h_desp], eax
        sub     edi, eax
        mov     [h_cell], ebx
        add     esi, ebx
        mov     edx, [rd_v_cnt_b]
        xor     ecx, ecx
        and     edx, 7
        add     esi, ebx
        mov     [line], edx
        xor     eax, eax
        mov     [flag_end], 0
next:
        mov     ebx, ecx
        add     ebx, [h_cell]
        cmp     ebx, [vdp+scrl_size_h]
        jle     no_flip_h
        mov     esi, [n_scrl]
        mov     [h_cell], 0
no_flip_h:
        mov     eax, dword ptr[esi]
        add     esi, 2
        xchg    ah, al
ok1:
        test    eax, 7ffh
        jz      no_print
        push    esi
        push    ecx
        lea     esi, [mem+vram]
        mov     ebx, eax
        mov     ecx, eax
        and     eax, 7ffh
        mov     edx, ebx
        shl     eax, 5
        nop
        shr     ebx, 13
        add     esi, eax
        and     ebx, 3
        shr     edx, 15
        nop
        shl     ebx, 4
        and     edx, 1
        shr     ecx, 11
        add     ebx, 16
;        cmp     [vdp+pal_effect], 1
;        jne     no_pal_effect
;        add     ebx, 64
;no_pal_effect:
        and     ecx, 3
        mov     bh, dl
        mov     edx, [line]
        shl     edx, 2
        cmp     ecx, 1
        jle     short no_vert_inv
        add     esi, 28
        sub     esi, edx
        jmp     short draw
no_vert_inv:
        add     esi, edx
draw:
        mov     eax, ecx
        mov     ecx, 4
        test    eax, eax
        jz      short next_nhi
        cmp     eax, 2
        jne     hi_draw
next_nhi:
        and     bh, bh
        jnz     psnext_nhi
snext_nhi:
        mov     eax, dword ptr[esi]
        mov     edx, dword ptr[edi]
        mov     cl, al
        shr     al, 4
        jz      short sblk_nhi1
        test    edx, 80h
        jnz     short sblk_nhi1
        add     al, bl
        mov     dl, al
sblk_nhi1:
        and     cl, 0fh
        jz      short sblk_nhi2
        test    edx, 8000h
        jnz     short sblk_nhi2
        add     cl, bl
        mov     dh, cl
sblk_nhi2:
        ror     edx, 16
        mov     cl, ah
        shr     ah, 4
        jz      short sblk_nhi3
        test    edx, 80h
        jnz     short sblk_nhi3
        add     ah, bl
        mov     dl, ah
sblk_nhi3:
        and     cl, 0fh
        jz      short sblk_nhi4
        test    edx, 8000h
        jnz     short sblk_nhi4
        add     cl, bl
        mov     dh, cl
sblk_nhi4:
        ror     edx, 16
        mov     dword ptr[edi], edx
        add     edi, 4
        shr     eax, 16
        mov     edx, dword ptr[edi]
        mov     cl, al
        shr     al, 4
        jz      short sblk_nhi5
        test    edx, 80h
        jnz     short sblk_nhi5
        add     al, bl
        mov     dl, al
sblk_nhi5:
        and     cl, 0fh
        jz      short sblk_nhi6
        test    edx, 8000h
        jnz     short sblk_nhi6
        add     cl, bl
        mov     dh, cl
sblk_nhi6:
        ror     edx, 16
        mov     cl, ah
        shr     ah, 4
        jz      short sblk_nhi7
        test    edx, 80h
        jnz     short sblk_nhi7
        add     ah, bl
        mov     dl, ah
sblk_nhi7:
        and     cl, 0fh
        jz      short sblk_nhi8
        test    edx, 8000h
        jnz     short sblk_nhi8
        add     cl, bl
        mov     dh, cl
sblk_nhi8:
        ror     edx, 16
        mov     dword ptr[edi], edx
        add     edi, 4
        jmp     done
psnext_nhi:
        mov     eax, dword ptr[esi]
        mov     cl, al
        shr     al, 4
        jz      short psblk_nhi1
        add     al, bl
        or      al, 80h
        mov     byte ptr[edi], al
psblk_nhi1:
        inc     edi
        and     cl, 0fh
        jz      short psblk_nhi2
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_nhi2:
        inc     edi
        mov     cl, ah
        shr     ah, 4
        jz      short psblk_nhi3
        add     ah, bl
        or      ah, 80h
        mov     byte ptr[edi], ah
psblk_nhi3:
        inc     edi
        and     cl, 0fh
        jz      short psblk_nhi4
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_nhi4:
        inc     edi
        shr     eax, 16
        mov     cl, al
        shr     al, 4
        jz      short psblk_nhi5
        add     al, bl
        or      al, 80h
        mov     byte ptr[edi], al
psblk_nhi5:
        inc     edi
        and     cl, 0fh
        jz      short psblk_nhi6
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_nhi6:
        inc     edi
        mov     cl, ah
        shr     ah, 4
        jz      short psblk_nhi7
        add     ah, bl
        or      ah, 80h
        mov     byte ptr[edi], ah
psblk_nhi7:
        inc     edi
        and     cl, 0fh
        jz      short psblk_nhi8
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_nhi8:
        inc     edi
        jmp     done
hi_draw:
        and     bh, bh
        jnz     psnext_hi
snext_hi:
        mov     eax, dword ptr[esi]
        mov     edx, dword ptr[edi]
        bswap   eax
        mov     cl, al
        and     al, 0fh
        jz      short sblk_hi1
        test    edx, 80h
        jnz     short sblk_hi1
        add     al, bl
        mov     byte ptr[edi], al
sblk_hi1:
        inc     edi
        shr     cl, 4
        jz      short sblk_hi2
        test    edx, 8000h
        jnz     short sblk_hi2
        add     cl, bl
        mov     byte ptr[edi], cl
sblk_hi2:
        inc     edi
        mov     cl, ah
        and     ah, 0fh
        jz      short sblk_hi3
        test    edx, 800000h
        jnz     short sblk_hi3
        add     ah, bl
        mov     byte ptr[edi], ah
sblk_hi3:
        inc     edi
        shr     cl, 4
        jz      short sblk_hi4
        test    edx, 80000000h
        jnz     short sblk_hi4
        add     cl, bl
        mov     byte ptr[edi], cl
sblk_hi4:
        inc     edi
        shr     eax, 16
        mov     edx, dword ptr[edi]
        mov     cl, al
        and     al, 0fh
        jz      short sblk_hi5
        test    edx, 80h
        jnz     short sblk_hi5
        add     al, bl
        mov     byte ptr[edi], al
sblk_hi5:
        inc     edi
        shr     cl, 4
        jz      short sblk_hi6
        test    edx, 8000h
        jnz     short sblk_hi6
        add     cl, bl
        mov     byte ptr[edi], cl
sblk_hi6:
        inc     edi
        mov     cl, ah
        and     ah, 0fh
        jz      short sblk_hi7
        test    edx, 800000h
        jnz     short sblk_hi7
        add     ah, bl
        mov     byte ptr[edi], ah
sblk_hi7:
        inc     edi
        shr     cl, 4
        jz      short sblk_hi8
        test    edx, 80000000h
        jnz     short sblk_hi8
        add     cl, bl
        mov     byte ptr[edi], cl
sblk_hi8:
        inc     edi
        jmp     done
psnext_hi:
        mov     eax, dword ptr[esi]
        bswap   eax
        mov     cl, al
        and     al, 0fh
        jz      short psblk_hi1
        add     al, bl
        or      al, 80h
        mov     byte ptr[edi], al
psblk_hi1:
        inc     edi
        shr     cl, 4
        jz      short psblk_hi2
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_hi2:
        inc     edi
        mov     cl, ah
        and     ah, 0fh
        jz      short psblk_hi3
        add     ah, bl
        or      ah, 80h
        mov     byte ptr[edi], ah
psblk_hi3:
        inc     edi
        shr     cl, 4
        jz      short psblk_hi4
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_hi4:
        inc     edi
        shr     eax, 16
        mov     cl, al
        and     al, 0fh
        jz      short psblk_hi5
        add     al, bl
        or      al, 80h
        mov     byte ptr[edi], al
psblk_hi5:
        inc     edi
        shr     cl, 4
        jz      short psblk_hi6
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_hi6:
        inc     edi
        mov     cl, ah
        and     ah, 0fh
        jz      short psblk_hi7
        add     ah, bl
        or      ah, 80h
        mov     byte ptr[edi], ah
psblk_hi7:
        inc     edi
        shr     cl, 4
        jz      short psblk_hi8
        add     cl, bl
        or      cl, 80h
        mov     byte ptr[edi], cl
psblk_hi8:
        inc     edi
done:
        pop     ecx
        pop     esi
        inc     ecx
        cmp     ecx, [th_cells]
        jne     next
        jmp     short ldone
no_print:
        inc     ecx
        add     edi, 8
        cmp     ecx, [th_cells]
        jne     next
ldone:
        cmp     [flag_end], 0
        jne     fdone

        add     edi, [h_desp]
        mov     eax, [vdp+h_cells]
        mov     esi, [rd_ptr_scrl_a]
        add     eax, 2
        mov     [n_scrl], esi
        mov     [th_cells], eax
        mov     eax, [rd_desp_a]
        sub     esi, 2
        mov     ebx, eax
        and     eax, 7
        shr     ebx, 3
        mov     [h_desp], eax
        sub     edi, eax
        mov     [h_cell], ebx
        add     esi, ebx
        mov     edx, [rd_v_cnt_a]
        xor     ecx, ecx
        and     edx, 7
        add     esi, ebx
        mov     [line], edx
        xor     eax, eax
        mov     [flag_end], 1
        cmp     [vdp+cell_mode], 0
        jne     f40_cell
        sub     edi, 272
        jmp     next
f40_cell:
        sub     edi, 336
        jmp     next
fdone:
        add     edi, [h_desp]
        cmp     [vdp+cell_mode], 0
        jne     short ffdone
        add     edi, 32
ffdone:
        mov     [rd_buffer_pos], edi
        
        popad

        ret

RenderLine      ENDP




_TEXT ENDS

   END
