
#ifndef UCLOCK__H
#define UCLOCK__H

#define CAST(new_type,old_object) (*((new_type *)(&(old_object))))

#include <dos.h>
#include <time.h>


typedef struct {
      unsigned short count;
      unsigned long  ticks;
} Uclock_T;

typedef double  uclock_t;

#define UCLK_TCK 1193181.667
#define UCLK_RLVR (uclock_t)(0x001800af * 65536.0 + 0xffff)


void Uclock_(Uclock_T *);
void SetMode2_(void);


uclock_t    usec_clock(Uclock_T *now);
uclock_t    uclock_diff(Uclock_T *Start, Uclock_T *Stop, Uclock_T *Diff);
uclock_t    uclock_cnvrt(Uclock_T *ticks);
void        usec_delay(unsigned long usecs);


#endif
